/**
 * prog3.c
 *
 * Tüketici.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <mqueue.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>

#define DISP_TIME struct timeval t; \
                  gettimeofday(&t, NULL); \
                  fprintf(stdout, "%ld.%06ld: ", t.tv_sec, t.tv_usec)

#define QUE "/test"
#define RND(MIN, MAX) (rand() % (MAX + 1 - MIN)) + MIN

int main(int argc, char *argv[]){

   mqd_t mq;
   char  buf[256];
   int   n;
   int   i;
   int   pri;

   // open
   mq= mq_open(QUE, O_WRONLY);
   if ( mq == -1 ){
      perror("mq_open()");
      return EXIT_FAILURE;
      }

   for(i= 0; i< 10; i++){

      pri= RND(1, 255);
      n= snprintf(buf, sizeof(buf), "merhaba_%03d_%03d\n", i, pri);

      DISP_TIME;

      if ( mq_send(mq, buf, n, pri) == -1 ){
         perror("mq_send()");
         break;
         }

      fprintf(stdout, " %s", buf);

      } 

   // close
   mq_close(mq);

   return EXIT_SUCCESS;
}


