/**
 * test2.c
 *
 * sigaction ile  sinyal yakalama.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>

void yakala(int sig){
   // printf() signal-safe değil.
   // write() kullanılmalı!
   fprintf(stdout, "yakalanan sinyal %s\n", strsignal(sig));
}

int main(){

   int i;
   struct sigaction act;

   act.sa_handler= &yakala;

   // Dönüşler kontrol edilmeli!
   sigaction(SIGINT,  &act, NULL);
   sigaction(SIGTERM, &act, NULL);

   for(i= 0; ;i++){
      fprintf(stdout, "no(%d);\n", i);
      sleep(1);
      }

   return EXIT_SUCCESS;
}



