/**
 * prog1.c
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/syscall.h>

#define RND(MIN, MAX) (rand() % (MAX + 1 - MIN)) + MIN

void *sum(void *ptr){

   int      *p;
   int       i;
   intptr_t  s;
   long      id; 
   long      t;

   id= syscall(SYS_gettid);
   srandom(time(NULL)*id);

   p= (int *)ptr;

   s= 0;

   for(i= 1; i<= p[0]; i++){
      s += p[i];
      t= RND(10000, 900000);
      fprintf(stdout, "%6ld: p[%d]= %d   usleep(%ld);\n", id, i, p[i], t);
      usleep(t);
      }
   
   fprintf(stdout, "%6ld: bitti\n", id);

   pthread_exit((void *)s);
}

int main(int argc, char *argv[]){

   pthread_t t1, t2;
   void      *r;

   pthread_create(&t1, NULL, sum, (void*)(int []){3, 1, 2, 3 } );
   pthread_create(&t2, NULL, sum, (void*)(int []){4, 2, 4, 6, 8 } );

   /* thread'lerin bitişini bekle.
    * Yoksa main durunca thread'ler düzgün bitmeyebilir.
    */
   pthread_join(t1, &r);
   fprintf(stdout, "sum1 %ld\n", (long)r);

   pthread_join(t2, &r); 
   fprintf(stdout, "sum2 %ld\n", (long)r);

   fprintf(stdout, "main bitti.\n");

   return EXIT_SUCCESS;
}

