
/**
 * prog4.c
 *
 * detachable thread örneği.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/syscall.h>

#define RND(MIN, MAX) (rand() % (MAX + 1 - MIN)) + MIN

void *sum(void *ptr){

   int  *p;
   int   i;
   int   s;
   long  id; 
   long  t;

   id= syscall(SYS_gettid);
   srandom(time(NULL)*id);

   p= (int *)ptr;

   s= 0;

   for(i= 1; i<= p[0]; i++){
      s += p[i];
      t= RND(10000, 900000);
      fprintf(stdout, "%6ld: p[%d]= %d   usleep(%ld);\n", id, i, p[i], t);
      usleep(t);
      }
   
   fprintf(stdout, "%6ld: bitti, toplam %d\n", id, s);

   return NULL;
}

int main(int argc, char *argv[]){

   pthread_t      t1, t2;
   pthread_attr_t tattr;

   pthread_attr_init(&tattr);
   pthread_attr_setdetachstate(&tattr,PTHREAD_CREATE_DETACHED);

   pthread_create(&t1, &tattr, sum, (void*)(int []){3, 1, 2, 3 } );
   pthread_create(&t2, &tattr, sum, (void*)(int []){4, 2, 4, 6, 8 } );

   // sleep(3);
   // pthread_exit(NULL);

   fprintf(stdout, "main bitti.\n");

   return EXIT_SUCCESS;
}

