/**
 * prog1.c
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

#include "test.h"

int main(int argc, char *argv[]){

   void *handle;
   char *error;

   int (*f)(int, int);

   handle = dlopen("./libtest.so", RTLD_LAZY);

   if ( handle == NULL ) {
      fprintf(stderr, "%s\n", dlerror());
      return EXIT_FAILURE;
      }

   // hata varsa temizle
   dlerror();	 

   f= (int (*)(int, int)) dlsym(handle, "mult");

   error= dlerror();
   if ( error != NULL) {
      fprintf(stderr, "%s\n", error);
      return EXIT_FAILURE;
      }

   fprintf(stdout, "evrene dair sorunun cevabı %d\n", f(6,7));

   if ( dlclose(handle) != 0 ){
      fprintf(stderr, "%s\n", error);
      return EXIT_FAILURE;
      }

   return EXIT_SUCCESS;
}
