/**
 * prog2.c
 *
 * Üretici.
 *
 * ctrl+d ile çık.
 * -lrt ile derle.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <mqueue.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>

#define DISP_TIME struct timeval t; \
                  gettimeofday(&t, NULL); \
                  fprintf(stdout, "%ld.%06ld: ", t.tv_sec, t.tv_usec)

#define QUE "/test"

int main(int argc, char *argv[]){

   mqd_t mq;
   char  buf[256];
   int   n;

   // open
   mq= mq_open(QUE, O_WRONLY);
   if ( mq == -1 ){
      perror("mq_open()");
      return EXIT_FAILURE;
      }

   // send
   while( (n= read(0, buf, sizeof(buf)- 1)) > 0 ){ 

        DISP_TIME;

        if ( mq_send(mq, buf, n, 0) == -1 ){
           perror("mq_send()");
           break;
           }

        buf[n]= '\0';
        fprintf(stdout, " %s\n", buf);
        }  

   // close
   mq_close(mq);

   return EXIT_SUCCESS;
}


