
/* hello.c */

#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/stat.h>

static char *my_city= "istanbul";

MODULE_LICENSE("GPL");
MODULE_AUTHOR("UCanLinux.Com");
MODULE_DESCRIPTION("A Simple Hello World module");
MODULE_VERSION("0.1");

module_param(my_city, charp, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
MODULE_PARM_DESC(my_city, "yaşadığınız şehir");

static int __init hello_init(void){
   printk(KERN_INFO "Hello world!\n");
   printk(KERN_INFO "Hello %s\n", my_city);
   return 0;    // Non-zero return means that the module couldn't be loaded.
}

static void __exit hello_cleanup(void){
   printk(KERN_INFO "Cleaning up module.\n");
}

module_init(hello_init);
module_exit(hello_cleanup);


