/* prog1.c */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/wait.h>

int main(int argc, char *argv[]){

   int   fd[2];
   pid_t cpid;
   char  c;

   if (argc != 2) {
      fprintf(stderr, "kullanımı: %s string\n", argv[0]);
      return EXIT_FAILURE;
      }

   if ( pipe(fd) == -1) {
      perror("pipe");
      return EXIT_FAILURE;
      }

   cpid= fork();

   if (cpid == -1) {
      perror("fork");
      return EXIT_FAILURE;
      }

   if (cpid == 0) { 
      // cocuk
      close(fd[1]);        

      while( read(fd[0], &c, 1) > 0){
           c= toupper(c);
           write(STDOUT_FILENO, &c, 1);
           }
       write(STDOUT_FILENO, "\n", 1);
       close(fd[0]);
       _exit(EXIT_SUCCESS);

       }

   // Anne
   close(fd[0]);          
   write(fd[1], argv[1], strlen(argv[1]));
   close(fd[1]);          

   // Çocuğun bitmesini bekle.
   // Tek proses beklendiği için pid vermeye gerek yoktur.
   wait(NULL);

   return EXIT_SUCCESS;
}

