/**
 * prog1.c
 *
 * Paylaşılan bellek kur.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>        
#include <fcntl.h>         

int main(int argc, char *argv[]){

   int fd;

   fd= shm_open("/ortak_bellek", O_CREAT|O_RDWR, 0600);
   if ( fd == -1 ){
      perror("shm_open()");
      return EXIT_FAILURE;
      }

   if ( ftruncate(fd, 1024) == -1 ){
      perror("shm_open()");
      return EXIT_FAILURE;
      }

   if ( close(fd) == -1 ){
      perror("shm_open()");
      return EXIT_FAILURE;
      }

   fprintf(stdout, "/ortak_bellek kuruldu.\n");

   return EXIT_SUCCESS;
}

